import sys
import os
import string

# 1. Setup variables:
# - src dir
# - dst dir

if len(sys.argv) != 3:
	print "Use: python stlsoft_hpp_maker.py <stlsoft root dir> <stlsoft inprogress dir>"
	sys.exit(-1)

src_path = sys.argv[1]
dst_path = sys.argv[2]

if not os.path.isdir(src_path):
	print "Invalid source path"
	sys.exit(-2)

if not os.path.isdir(dst_path):
	print "Invalid destination path"
	sys.exit(-3)

# 2. Locate all files that might need updating
file_list = os.listdir(src_path)

# 3. For each file
total_fixed = 0

file_contents =\
	"#ifndef %(pp)s\n"\
	"#define %(pp)s\n"\
	"\n"\
	"#ifndef %(old_pp)s\n"\
	"# include <%(old_file)s>\n"\
	"#endif /* !%(old_pp)s */\n"\
	"\n"\
	"#endif /* !%(pp)s */\n"
	
for f in file_list:
	upos = f.find("_")
	if upos == -1:
		continue

	if upos == 0:
		continue

#    3.1. Generate corresponding path on the new file tree
	dir_name = f[0 : upos]
	new_name = os.path.join(dst_path, dir_name, f[upos + 1:] + "pp")

#    3.2 Check if file exists or not
	if not os.path.exists(new_name):
		udir_name		= string.upper(dir_name)
		file_name		= os.path.basename(new_name)
		ufile_name		= string.upper(file_name[0 : len(file_name) - 4])
		pp_define		= udir_name + "_INCL_" + udir_name + "_HPP_" + ufile_name
		old_pp_define	= udir_name + "_INCL_H_" + udir_name + "_" + ufile_name
			
		contents = file_contents %\
			{\
			'pp'		: pp_define,\
			'old_pp'	: old_pp_define,\
			'old_file': f \
			}
		
		out_file		= file(new_name, 'w')
		out_file.write(contents)
		out_file.close()
		
		total_fixed		= total_fixed + 1
		
#    3.3 If not, create it
#    3.4 Fill newly created file
print '\n', total_fixed, "files created"